# -*- coding: utf-8 -*-
# Version: 1.0.7
# Author: Fastshare.cz
# Support: info@fastshare.cz

#define	ACTION_SHOW_SUBTITLES	25

import urllib
from urllib import quote_plus
import sys, os, re, time
import xbmc, xbmcaddon, xbmcplugin, xbmcgui
import base64, json, random, hashlib

addon = xbmcaddon.Addon()

lang = addon.getLocalizedString

addon_name = addon.getAddonInfo('name')
addon_icon= addon.getAddonInfo('icon')

xbmc.executebuiltin("Dialog.Close(all, true)", True)

addon.setSetting('entered_pin', '')
addon.setSetting('pin_timeout', '0')

set_subs = False

#xbmc.log(sys.argv[0],level=xbmc.LOGNOTICE)

if addon.getSetting("run_fs") == "true":
	xbmc.executebuiltin('RunAddon(plugin.video.fastshare)')

if addon.getSetting('deviceid')=="":
	result = hashlib.md5(addon.getSetting('devicename') + str(random.randint(0,9999999999999)) + str(time.time()))
	reshex = result.hexdigest()
	addon.setSetting('deviceid', reshex)

if addon.getSetting('devicename')=="":
	xbmc.log("-- devicename empty", level=xbmc.LOGNOTICE)
	if os.getenv('COMPUTERNAME'):
		devicename = os.getenv('COMPUTERNAME')
		xbmc.log("-- os getenv " + devicename, level=xbmc.LOGNOTICE)
	else:
		deviceid = addon.getSetting('deviceid')
		devicename = "zarizeni-" + deviceid[:3]
		xbmc.log("-- neni os getenv " + devicename, level=xbmc.LOGNOTICE)
	addon.setSetting('devicename', devicename)

AddonName = xbmc.getInfoLabel('Container.PluginName')
AddonName = xbmcaddon.Addon(AddonName).getAddonInfo('name')

player = xbmc.Player()

langs = {
	'-': 'none',
	'Czech': 'cze',
	'English': 'eng',
	'Polish': 'pol',
	'Slovak': 'slo'
	}

def notify(msg, timeout=3000):
	xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(AddonName, msg.encode('utf-8'), timeout, addon_icon))

if __name__ == '__main__':
	monitor = xbmc.Monitor()

	while not monitor.abortRequested():

		#xbmc.log(AddonName + " Monitor %s" % time.time(), level=xbmc.LOGNOTICE)
		
		url = "https://fastshare.cz/api/api_kodi.php?process=getqueue&devicename=" + base64.b64encode(addon.getSetting('devicename')) + "&deviceid=" + addon.getSetting('deviceid') + "&hash=" + addon.getSetting('hash') + "&t=%s" % time.time()
		#xbmc.log(url, level=xbmc.LOGNOTICE)		

		try:
			f = urllib.urlopen(url)
			if (f):
				response = f.read()
				jr = json.loads(response)

				if jr['result'] == "true":
					addon.setSetting('set_subs', 'true')
					file = jr['play']
					
					url = "https://fastshare.cz/api/api_kodi.php?process=clearqueue&id_md5=" + jr['id_md5']
					f = urllib.urlopen(url)

					cookie = urllib.quote_plus("FASTSHARE=" + addon.getSetting('hash'))
					vfinal = file + "|cookie=" + cookie;
					player.play(item=vfinal)

		except IOError as err:
			notify(lang(30020), 5000)

		if player.isPlaying() and addon.getSetting('auto_set') == "true" and addon.getSetting('set_subs') == "true":
			subtitles1_ = addon.getSetting('subtitles1')
			subtitles1 = langs[subtitles1_]
			subtitles2_ = addon.getSetting('subtitles2')
			subtitles2 = langs[subtitles2_]
			audio1_ = addon.getSetting('audio1')			
			audio1 = langs[audio1_]
			audio2_ = addon.getSetting('audio2')
			audio2 = langs[audio2_]
			xbmc.log(" - - - player is isPlaying and set_subs = True", level=xbmc.LOGNOTICE)
			xbmc.log(" - - - - settings: " + subtitles1 + "/" + audio1 + ", " + subtitles2 + "/" + audio2, level=xbmc.LOGNOTICE)
			subs = player.getAvailableSubtitleStreams()
			audios = player.getAvailableAudioStreams()
			xbmc.sleep(250)
			i = 0

			found_subs_stream = -1
			found_audio_stream = -1

			#main settings
			for sub in subs:				
				xbmc.log(" - - - - subtitles1: " + sub + " = " + subtitles1, level=xbmc.LOGNOTICE)
				if(sub==subtitles1):
					xbmc.log(" - - - - nastaveni sub1 souhlasi: " + sub + "=" + subtitles1 + " (" + str(i) + ")", level=xbmc.LOGNOTICE)
					found_subs_stream = i
					break
				i += 1
			i = 0
			for audio in audios:				
				xbmc.log(" - - - - audio1: " + audio + " = " + audio1, level=xbmc.LOGNOTICE)
				if(audio==audio1):
					xbmc.log(" - - - - nastaveni audio1 souhlasi: " + audio + "=" + audio1 + " (" + str(i) + ")", level=xbmc.LOGNOTICE)
					found_audio_stream = i
					break
				i += 1			

			if (found_audio_stream > -1 or found_subs_stream >-1) or (found_audio_stream > -1 and subtitles1=='none'):
				xbmc.log(" - - - - setting both streams1", level=xbmc.LOGNOTICE)				
				if subtitles1=='none':
					player.showSubtitles(False)
					xbmc.log(" - - - - disabling subtitles", level=xbmc.LOGNOTICE)				
				elif found_subs_stream > -1:
					player.showSubtitles(True)
					xbmc.log(" - - - - setting subtitles", level=xbmc.LOGNOTICE)				
					player.setSubtitleStream(found_subs_stream)
				player.setAudioStream(found_audio_stream)
				addon.setSetting('set_subs', 'false')
			else:
				xbmc.log(" - - - - IGNORING 1", level=xbmc.LOGNOTICE)				
				found_subs_stream = -1
				found_audio_stream = -1

			#alternative settings			
			if addon.getSetting('set_subs') == 'true':
				i = 0			
				for sub in subs:
					xbmc.log(" - - - - sub2: " + sub, level=xbmc.LOGNOTICE)
					if(sub==subtitles2):
						xbmc.log(" - - - - found settings2 sub: " + sub, level=xbmc.LOGNOTICE)
						found_subs_stream = i
						break
					i += 1
				i = 0
				for audio in audios:
					xbmc.log(" - - - - audio2: " + audio, level=xbmc.LOGNOTICE)
					if(audio==audio2):
						xbmc.log(" - - - - found settings2 audio: " + sub, level=xbmc.LOGNOTICE)
						found_audio_stream = i
						break
					i += 1			

				if (found_audio_stream > -1 or found_subs_stream >-1) or (found_audio_stream > -1 and subtitles2=='none'):
					xbmc.log(" - - - - setting both streams1", level=xbmc.LOGNOTICE)				
					if subtitles2=='none':
						player.showSubtitles(False)
						xbmc.log(" - - - - disabling subtitles", level=xbmc.LOGNOTICE)				
					elif found_subs_stream > -1:
						player.showSubtitles(True)
						xbmc.log(" - - - - setting subtitles", level=xbmc.LOGNOTICE)				
						player.setSubtitleStream(found_subs_stream)
					player.setAudioStream(found_audio_stream)
					addon.setSetting('set_subs', 'false')
				else:
					found_subs_stream = -1
					found_audio_stream = -1
					xbmc.log(" - - - - IGNORING 2", level=xbmc.LOGNOTICE)				

			addon.setSetting('set_subs', 'false')
				
		else:
			addon.setSetting('set_subs', 'false')

		if monitor.waitForAbort(5):
			#xbmc.log(AddonName + " ---ABORTED---",level=xbmc.LOGNOTICE)
			break